import { ModuleWithProviders } from '@angular/core';
import { YaMarker } from './directives/marker';
import { YaClaster } from './directives/claster';
import { YaObjectManager } from './directives/objectManager';
import { YaMapsAPILoaderConfigLiteral } from './services/ya-maps-loader';
import { YaMap } from './directives/ymap';
export * from './ya-maps-types';
/**
 * @internal
 */
export declare function coreDirectives(): (typeof YaMarker | typeof YaClaster | typeof YaObjectManager | typeof YaMap)[];
/**
 * The angular-ya-maps core module. Contains all Directives/Services/Pipes
 * of the core module. Please use `YaCoreModule.forRoot()` in your app module.
 */
export declare class YaCoreModule {
    /**
     * Please use this method when you register the module at the root level.
     */
    static forRoot(yaMapsAPILoaderConfig: YaMapsAPILoaderConfigLiteral): ModuleWithProviders;
}
export declare function YaCoreModuleForRoot(yaMapsAPILoaderConfig: YaMapsAPILoaderConfigLiteral): ModuleWithProviders<any>[];
