import { ElementRef, EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { YaMapsAPIWrapper } from '../ya-maps-api-wrapper';
import * as mapTypes from '../ya-maps-types';
export declare class YaMap implements OnInit, OnDestroy, OnChanges {
    private _elem;
    private _mapsWrapper;
    longitude: number;
    latitude: number;
    zoom: number;
    minZoom: number;
    maxZoom: number;
    mapType: any;
    controls: any[];
    panToObjects: mapTypes.PanToObjects;
    crosshair: boolean;
    mapClick: EventEmitter<mapTypes.MapClickMouseEvent>;
    actionTick: EventEmitter<mapTypes.MapClickMouseEvent>;
    boundschange: EventEmitter<mapTypes.MapClickMouseEvent>;
    mapInit: boolean;
    private _observableSubscriptions;
    constructor(_elem: ElementRef, _mapsWrapper: YaMapsAPIWrapper);
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: SimpleChanges): void;
    private _initMapInstance;
    private updatePosition;
    private panTo;
    private _handleMapMouseEvents;
}
